/**
 * Created on 14-08-2002
 *
 * The contents of this file may be used for 
 * private or educational use only.
 */
package util;

import java.util.*;
/**
 * @author Knud Ahrnell Albrechtsen (SnakeByte)
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class LanguageObserver extends Observable {

private String[] engfilearray  = { "File", "Preferences", "Save", "Exit" };
private String[] engprefsarray = { "Global", "Look And Feel", "Language" };
private String[] enghelparray  = { "Help", "About", "Help" };
private String[] englangarray  = { "Danish", "English", "German" };

private String[] danfilearray  = { "Fil", "Preferencer", "Gem", "Slut" };
private String[] danprefsarray = { "Global", "Udseende", "Sprog" };
private String[] danhelparray  = { "Hjlp", "Om", "Hjlp" };
private String[] danlangarray  = { "Dansk", "Engelsk", "Tysk" };

private String[] gerfilearray  = { "Fil", "Preferencer", "Gem", "Ende" };
private String[] gerprefsarray = { "Global", "Ausseende", "Sprache" };
private String[] gerhelparray  = { "Hilfe", "Om", "Hilfe" };
private String[] gerlangarray  = { "Dnish", "English", "Deutch" };

private Object[] arr = new Object[4];

private Locale[] supported = { Locale.ENGLISH, Locale.GERMAN, Locale.FRANCE, new Locale( "da", "DK" ) };


	/**
	 * Constructor for LanguageObserver.
	 */
	public LanguageObserver(  ) {
		arr[0] = engfilearray;
		arr[1] = engprefsarray;
		arr[2] = enghelparray;
		arr[3] = englangarray;
	}
	
	/**
	 * @param locale
	 * @return Object[]
	 */
	private Object[] constructArrays( Locale locale ) {
		Object[] arr = new Object[4];
		ResourceBundle bundle = ResourceBundle.getBundle( "util.menues", locale );
		String[] filearray = { bundle.getString( "File" ), bundle.getString( "Preferences" ), bundle.getString( "Save" ), bundle.getString( "Exit" ) };
		String[] prefsarray = { bundle.getString( "Global" ), bundle.getString( "Look_And_Feel" ).replace( '_', ' ' ), bundle.getString( "Language" ) };
		String[] helparray = { bundle.getString( "Help" ), bundle.getString( "About" ), bundle.getString( "Help" ) };
		String[] langarray = { bundle.getString( "Danish" ), bundle.getString( "English" ), bundle.getString( "German" ) };
		arr[0] = filearray;
		arr[1] = prefsarray;
		arr[2] = helparray;
		arr[3] = langarray;
		return arr;
	}
	
	/**
	 * @param lang
	 */
	public void setLanguage( String lang ) {
		if( lang.equals( "Danish" )  ) {
//			printArray( constructArrays( supported[3] ) );
//			arr[0] = danfilearray;
//			arr[1] = danprefsarray;
//			arr[2] = danhelparray;
//			arr[3] = danlangarray;
//			notifyObservers( arr );
			setChanged();
			notifyObservers( constructArrays( supported[3] ) );
		}
		else if( lang.equals( "English" ) ) {
			setChanged();
			notifyObservers( constructArrays( supported[0] ) );
		}
		else if( lang.equals( "German" ) ) {
			setChanged();
			notifyObservers( constructArrays( supported[1] ) );
		}
	}
}
